//*********************************************************************
// PS_ConfigClient -- Controls configuration window appearance
// Created by mrbond113
//*********************************************************************

class PS_ConfigClient extends UWindowDialogClientWindow config (ProjSwap);

var config int PrimaryProj[10];
var config int SecodaryProj[10];
var config float Speeds[12];
var localized string Projs[12];
var localized string Weaps[10];
var UWindowComboControl cmbPrimary[10];
var UWindowComboControl cmbSecondary[10];
var UWindowEditControl txtSpeeds[12];
var UWindowLabelControl txtHeader, txtFire, txtAltFire, txtSpeed, txtWeb, txtSniper;

function Created()
{
	local int ControlWidth, ControlLeft, ControlRight, ControlOffset;
	local int CenterWidth, CenterPos, i, j, l, m;

	Super.Created();
	ControlWidth = WinWidth/3;
	ControlLeft = (WinWidth/2 - ControlWidth)/2;
	ControlRight = WinWidth/2 + ControlLeft;

	CenterWidth = 192;
	CenterPos = 16;

	ControlOffset += 20;
  	txtHeader = UWindowLabelControl(CreateControl(class'UWindowLabelControl', CenterPos + 80, ControlOffset, CenterWidth, 1));
  	txtHeader.SetText("Projectile Swapper Configuration");
  	txtHeader.SetFont(F_Bold);

  	ControlOffset += 20;
  	txtFire = UWindowLabelControl(CreateControl(class'UWindowLabelControl', CenterPos + 132, ControlOffset, CenterWidth, 1));
  	txtFire.SetText("Fire");
  	txtFire.SetFont(F_Normal);
  	txtAltFire = UWindowLabelControl(CreateControl(class'UWindowLabelControl', CenterPos + 256, ControlOffset, CenterWidth, 1));
  	txtAltFire.SetText("Alt Fire");
  	txtAltFire.SetFont(F_Normal);

    for(j=0; j<10; j++)
    {
        ControlOffset += 20;
        cmbPrimary[j] = UWindowComboControl(CreateControl(class'UWindowComboControl', CenterPos, ControlOffset, CenterWidth, 1));
   	    cmbPrimary[j].SetText((Weaps[j]));
   	    cmbPrimary[j].SetFont(F_Normal);
   	    cmbPrimary[j].SetEditable(False);

   	    cmbSecondary[j] = UWindowComboControl(CreateControl(class'UWindowComboControl', CenterPos + 128, ControlOffset, CenterWidth, 1));
//   	    cmbSecondary[j].SetText((Weaps[j]$" AltFire"));
   	    cmbSecondary[j].SetFont(F_Normal);
   	    cmbSecondary[j].SetEditable(False);
   	    for(i=0; i<12; i++)
   	    {
            cmbPrimary[j].AddItem(Projs[i]);
            if(Weaps[j]=="Sniper Rifle" || Weaps[j]=="Redeemer")
            {
               cmbSecondary[j].AddItem("Not Available");
               continue;
            }
            cmbSecondary[j].AddItem(Projs[i]);
   	    }
    }

    ControlOffset += 40;
    txtSpeed = UWindowLabelControl(CreateControl(class'UWindowLabelControl', CenterPos + 128, ControlOffset, CenterWidth, 1));
  	txtSpeed.SetText("Projectile Speed");
  	txtSpeed.SetFont(F_Normal);

  	for(l=0; l<6; l++)
  	{
 	    ControlOffset += 20;
  	    for(m=0; m<2; m++)
  	    {
  	        txtSpeeds[(l*2+m)] = UWindowEditControl(CreateControl(class'UWindowEditControl', CenterPos + (m*176) - 8, ControlOffset, 160, 1));
  	        txtSpeeds[(l*2+m)].SetText(Projs[(l*2+m)]);
  	    }
    }

    ControlOffset += 40;
    txtWeb = UWindowLabelControl(CreateControl(class'UWindowLabelControl', CenterPos + 30, ControlOffset, 360, 1));
  	txtWeb.SetText("http://perfectdark.beyondunreal.com/bonddesign");
  	txtWeb.SetFont(F_Bold);

    cmbPrimary[0].SetSelectedIndex (class'PS_Enforcer'.default.PrimaryProj);
    cmbPrimary[1].SetSelectedIndex (class'PS_BioRifle'.default.PrimaryProj);
    cmbPrimary[2].SetSelectedIndex (class'PS_ShockRifle'.default.PrimaryProj);
    cmbPrimary[3].SetSelectedIndex (class'PS_PulseGun'.default.PrimaryProj);
    cmbPrimary[4].SetSelectedIndex (class'PS_Ripper'.default.PrimaryProj);
    cmbPrimary[5].SetSelectedIndex (class'PS_Minigun'.default.PrimaryProj);
    cmbPrimary[6].SetSelectedIndex (class'PS_FlakCannon'.default.PrimaryProj);
    cmbPrimary[7].SetSelectedIndex (class'PS_RocketLauncher'.default.PrimaryProj);
    cmbPrimary[8].SetSelectedIndex (class'PS_SniperRifle'.default.PrimaryProj);
    cmbPrimary[9].SetSelectedIndex (class'PS_Redeemer'.default.PrimaryProj);

    cmbSecondary[0].SetSelectedIndex (class'PS_Enforcer'.default.SecondaryProj);
    cmbSecondary[1].SetSelectedIndex (class'PS_BioRifle'.default.SecondaryProj);
    cmbSecondary[2].SetSelectedIndex (class'PS_ShockRifle'.default.SecondaryProj);
    cmbSecondary[3].SetSelectedIndex (class'PS_PulseGun'.default.SecondaryProj);
    cmbSecondary[4].SetSelectedIndex (class'PS_Ripper'.default.SecondaryProj);
    cmbSecondary[5].SetSelectedIndex (class'PS_Minigun'.default.SecondaryProj);
    cmbSecondary[6].SetSelectedIndex (class'PS_FlakCannon'.default.SecondaryProj);
    cmbSecondary[7].SetSelectedIndex (class'PS_RocketLauncher'.default.SecondaryProj);

    txtSpeeds[0].SetValue("Not Available");
    txtSpeeds[1].SetValue(string(class'PS_SmallBioProj'.default.ProjSpeed));
    txtSpeeds[2].SetValue(string(class'PS_LargeBioProj'.default.ProjSpeed));
    txtSpeeds[3].SetValue(string(class'PS_ShockProj'.default.ProjSpeed));
    txtSpeeds[4].SetValue(string(class'PS_PulseProj'.default.ProjSpeed));
    txtSpeeds[5].SetValue(string(class'PS_RazorProj'.default.ProjSpeed));
    txtSpeeds[6].SetValue(string(class'PS_RazorAltProj'.default.ProjSpeed));
    txtSpeeds[7].SetValue(string(class'PS_FlakChunkProj'.default.ProjSpeed));
    txtSpeeds[8].SetValue(string(class'PS_FlakShellProj'.default.ProjSpeed));
    txtSpeeds[9].SetValue(string(class'PS_RocketProj'.default.ProjSpeed));
    txtSpeeds[10].SetValue(string(class'PS_GrenadeProj'.default.ProjSpeed));
    txtSpeeds[11].SetValue(string(class'PS_WarheadProj'.default.ProjSpeed));
}


function SaveEverything()
{
    class'PS_Enforcer'.default.PrimaryProj=cmbPrimary[0].GetSelectedIndex();
    class'PS_Enforcer'.default.SecondaryProj=cmbSecondary[0].GetSelectedIndex();
    class'PS_Enforcer'.static.StaticSaveConfig();
    class'PS_BioRifle'.default.PrimaryProj=cmbPrimary[1].GetSelectedIndex();
    class'PS_BioRifle'.default.SecondaryProj=cmbSecondary[1].GetSelectedIndex();
    class'PS_BioRifle'.static.StaticSaveConfig();
    class'PS_ShockRifle'.default.PrimaryProj=cmbPrimary[2].GetSelectedIndex();
    class'PS_ShockRifle'.default.SecondaryProj=cmbSecondary[2].GetSelectedIndex();
    class'PS_ShockRifle'.static.StaticSaveConfig();
    class'PS_PulseGun'.default.PrimaryProj=cmbPrimary[3].GetSelectedIndex();
    class'PS_PulseGun'.default.SecondaryProj=cmbSecondary[3].GetSelectedIndex();
    class'PS_PulseGun'.static.StaticSaveConfig();
    class'PS_Ripper'.default.PrimaryProj=cmbPrimary[4].GetSelectedIndex();
    class'PS_Ripper'.default.SecondaryProj=cmbSecondary[4].GetSelectedIndex();
    class'PS_Ripper'.static.StaticSaveConfig();
    class'PS_Minigun'.default.PrimaryProj=cmbPrimary[5].GetSelectedIndex();
    class'PS_Minigun'.default.SecondaryProj=cmbSecondary[5].GetSelectedIndex();
    class'PS_Minigun'.static.StaticSaveConfig();
    class'PS_FlakCannon'.default.PrimaryProj=cmbPrimary[6].GetSelectedIndex();
    class'PS_FlakCannon'.default.SecondaryProj=cmbSecondary[6].GetSelectedIndex();
    class'PS_FlakCannon'.static.StaticSaveConfig();
    class'PS_RocketLauncher'.default.PrimaryProj=cmbPrimary[7].GetSelectedIndex();
    class'PS_RocketLauncher'.default.SecondaryProj=cmbSecondary[7].GetSelectedIndex();
    class'PS_RocketLauncher'.static.StaticSaveConfig();
    class'PS_SniperRifle'.default.PrimaryProj=cmbPrimary[8].GetSelectedIndex();
    class'PS_SniperRifle'.static.StaticSaveConfig();
    class'PS_Redeemer'.default.PrimaryProj=cmbPrimary[9].GetSelectedIndex();
    class'PS_Redeemer'.static.StaticSaveConfig();

    class'PS_SmallBioProj'.default.ProjSpeed=float(txtSpeeds[1].GetValue());
    class'PS_SmallBioProj'.static.StaticSaveConfig();
    class'PS_LargeBioProj'.default.ProjSpeed=float(txtSpeeds[2].GetValue());
    class'PS_LargeBioProj'.static.StaticSaveConfig();
    class'PS_ShockProj'.default.ProjSpeed=float(txtSpeeds[3].GetValue());
    class'PS_ShockProj'.static.StaticSaveConfig();
    class'PS_PulseProj'.default.ProjSpeed=float(txtSpeeds[4].GetValue());
    class'PS_PulseProj'.static.StaticSaveConfig();
    class'PS_RazorProj'.default.ProjSpeed=float(txtSpeeds[5].GetValue());
    class'PS_RazorProj'.static.StaticSaveConfig();
    class'PS_RazorAltProj'.default.ProjSpeed=float(txtSpeeds[6].GetValue());
    class'PS_RazorAltProj'.static.StaticSaveConfig();
    class'PS_FlakChunkProj'.default.ProjSpeed=float(txtSpeeds[7].GetValue());
    class'PS_FlakChunkProj'.static.StaticSaveConfig();
    class'PS_FlakShellProj'.default.ProjSpeed=float(txtSpeeds[8].GetValue());
    class'PS_FlakShellProj'.static.StaticSaveConfig();
    class'PS_RocketProj'.default.ProjSpeed=float(txtSpeeds[9].GetValue());
    class'PS_RocketProj'.static.StaticSaveConfig();
    class'PS_GrenadeProj'.default.ProjSpeed=float(txtSpeeds[10].GetValue());
    class'PS_GrenadeProj'.static.StaticSaveConfig();
    class'PS_WarheadProj'.default.ProjSpeed=float(txtSpeeds[11].GetValue());
    class'PS_WarheadProj'.static.StaticSaveConfig();
}

function Close(optional bool bByParent)
{
    SaveEverything();
    Super.Close(bByParent);
}

defaultproperties
{
    Projs(0)="Default"
    Projs(1)="Small Bio Glob"
    Projs(2)="Large Bio Glob"
    Projs(3)="Shock Ball"
    Projs(4)="Plasma Ball"
    Projs(5)="Bouncing Razor"
    Projs(6)="Exploding Razor"
    Projs(7)="Flak Chunk"
    Projs(8)="Flak Shell"
    Projs(9)="Rocket"
    Projs(10)="Grenade"
    Projs(11)="Nuclear Warhead"
    Weaps(0)="Enforcer"
    Weaps(1)="Bio Rifle"
    Weaps(2)="Shock Rifle"
    Weaps(3)="Pulse Gun"
    Weaps(4)="Ripper"
    Weaps(5)="Minigun"
    Weaps(6)="Flak Cannon"
    Weaps(7)="Rocket Launcher"
    Weaps(8)="Sniper Rifle"
    Weaps(9)="Redeemer"
}
