//*****************************************************************************
// PS_FlakCannon -- Modified Shock Rifle
// Created by mrbond113
//*****************************************************************************

class PS_FlakCannon extends UT_FlakCannon config(ProjSwap);

var config int PrimaryProj;
var config int SecondaryProj;

function Fire( float Value )
{
	local Vector Start, X,Y,Z;
	local Bot B;
	local Pawn P;

	if ( AmmoType == None )
	{
		// ammocheck
		GiveAmmo(Pawn(Owner));
	}
	if (AmmoType.UseAmmo(1))
	{
		bCanClientFire = true;
		bPointing=True;
		Start = Owner.Location + CalcDrawOffset();
		B = Bot(Owner);
		P = Pawn(Owner);
		P.PlayRecoil(FiringSpeed);
		Owner.MakeNoise(2.0 * P.SoundDampening);
		AdjustedAim = P.AdjustAim(AltProjectileSpeed, Start, AimError, True, bWarnTarget);
		GetAxes(AdjustedAim,X,Y,Z);
		Spawn(class'WeaponLight',,'',Start+X*20,rot(0,0,0));
		Start = Start + (FireOffset.X * X) + (16 * Z) + FireOffset.Y * Y + FireOffset.Z * Z;

        if(ProjectileClass != class'Botpack.UTChunk1')
        {
            Spawn( ProjectileClass,, '', Start, AdjustedAim);
		    Spawn( ProjectileClass,, '', Start - Z, AdjustedAim);
		    Spawn( ProjectileClass,, '', Start + 2 * Y + Z, AdjustedAim);
		    Spawn( ProjectileClass,, '', Start - Y, AdjustedAim);
		    Spawn( ProjectileClass,, '', Start + 2 * Y - Z, AdjustedAim);
		    Spawn( ProjectileClass,, '', Start, AdjustedAim);

		    // lower skill bots fire less flak chunks
		    if ( (B == None) || !B.bNovice || ((B.Enemy != None) && (B.Enemy.Weapon != None) && B.Enemy.Weapon.bMeleeWeapon) )
		    {
			    Spawn( ProjectileClass,, '', Start + Y - Z, AdjustedAim);
			    Spawn( ProjectileClass,, '', Start + 2 * Y + Z, AdjustedAim);
		    }
		    else if ( B.Skill > 1 )
			    Spawn( ProjectileClass,, '', Start + Y - Z, AdjustedAim);
        }
        else
        {
            Spawn( class 'UTChunk1',, '', Start, AdjustedAim);
		    Spawn( class 'UTChunk2',, '', Start - Z, AdjustedAim);
		    Spawn( class 'UTChunk3',, '', Start + 2 * Y + Z, AdjustedAim);
		    Spawn( class 'UTChunk4',, '', Start - Y, AdjustedAim);
		    Spawn( class 'UTChunk1',, '', Start + 2 * Y - Z, AdjustedAim);
		    Spawn( class 'UTChunk2',, '', Start, AdjustedAim);

		    // lower skill bots fire less flak chunks
		    if ( (B == None) || !B.bNovice || ((B.Enemy != None) && (B.Enemy.Weapon != None) && B.Enemy.Weapon.bMeleeWeapon) )
		    {
			    Spawn( class 'UTChunk3',, '', Start + Y - Z, AdjustedAim);
			    Spawn( class 'UTChunk4',, '', Start + 2 * Y + Z, AdjustedAim);
		    }
		    else if ( B.Skill > 1 )
			    Spawn( class 'UTChunk3',, '', Start + Y - Z, AdjustedAim);
		}

		ClientFire(Value);
		GoToState('NormalFire');
	}
}

function AltFire( float Value )
{
	local Vector Start, X,Y,Z;

	if ( AmmoType == None )
	{
		// ammocheck
		GiveAmmo(Pawn(Owner));
	}
	if (AmmoType.UseAmmo(1))
	{
		Pawn(Owner).PlayRecoil(FiringSpeed);
		bPointing=True;
		bCanClientFire = true;
		Owner.MakeNoise(Pawn(Owner).SoundDampening);
		GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
		Start = Owner.Location + CalcDrawOffset();
		Spawn(class'WeaponLight',,'',Start+X*20,rot(0,0,0));
		Start = Start + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;
		AdjustedAim = pawn(owner).AdjustToss(AltProjectileSpeed, Start, AimError, True, bAltWarnTarget);
		if(AltProjectileClass != class'Botpack.flakslug')
		{
		    Spawn(AltProjectileClass,,, Start,AdjustedAim);
		}
        else
		{
		    Spawn(class'FlakSlug',,, Start,AdjustedAim);
        }
		ClientAltFire(Value);
		GoToState('AltFiring');
	}
}

simulated function PostBeginPlay()
{
    switch(PrimaryProj)
    {
        case 0:
            ProjectileClass=class'Botpack.UTChunk1';
            break;
        case 1:
            ProjectileClass=class'ProjSwap.PS_SmallBioProj';
            break;
        case 2:
            ProjectileClass=class'ProjSwap.PS_LargeBioProj';
            break;
        case 3:
            ProjectileClass=class'ProjSwap.PS_ShockProj';
            break;
        case 4:
            ProjectileClass=class'ProjSwap.PS_PulseProj';
            break;
        case 5:
            ProjectileClass=class'ProjSwap.PS_RazorProj';
            break;
        case 6:
            ProjectileClass=class'ProjSwap.PS_RazorAltProj';
            break;
        case 7:
            ProjectileClass=class'ProjSwap.PS_FlakChunkProj';
            break;
        case 8:
            ProjectileClass=class'ProjSwap.PS_FlakShellProj';
            break;
        case 9:
            ProjectileClass=class'ProjSwap.PS_RocketProj';
            break;
        case 10:
            ProjectileClass=class'ProjSwap.PS_GrenadeProj';
            break;
        case 11:
            ProjectileClass=class'ProjSwap.PS_WarheadProj';
            break;
    }
    switch(SecondaryProj)
    {
        case 0:
            AltProjectileClass=class'Botpack.flakslug';
            break;
        case 1:
            AltProjectileClass=class'ProjSwap.PS_SmallBioProj';
            break;
        case 2:
            AltProjectileClass=class'ProjSwap.PS_LargeBioProj';
            break;
        case 3:
            AltProjectileClass=class'ProjSwap.PS_ShockProj';
            break;
        case 4:
            AltProjectileClass=class'ProjSwap.PS_PulseProj';
            break;
        case 5:
            AltProjectileClass=class'ProjSwap.PS_RazorProj';
            break;
        case 6:
            AltProjectileClass=class'ProjSwap.PS_RazorAltProj';
            break;
        case 7:
            AltProjectileClass=class'ProjSwap.PS_FlakChunkProj';
            break;
        case 8:
            AltProjectileClass=class'ProjSwap.PS_FlakShellProj';
            break;
        case 9:
            AltProjectileClass=class'ProjSwap.PS_RocketProj';
            break;
        case 10:
            AltProjectileClass=class'ProjSwap.PS_GrenadeProj';
            break;
        case 11:
            AltProjectileClass=class'ProjSwap.PS_WarheadProj';
            break;
    }
    super.PostBeginPlay();
}
defaultproperties
{
}
