//*****************************************************************************
// PS_Minigun -- Modified Minigun
// Created by mrbond113
//*****************************************************************************

class PS_Minigun extends minigun2 config(ProjSwap);

var config int PrimaryProj;
var config int SecondaryProj;
var string FireTag;

function TraceFire( float Accuracy )
{
    local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z, AimDir;
    local actor Other;

    if((FireTag=="primary" && ProjectileClass != none) || (FireTag=="secondary" && AltProjectileClass != none))
    {
        Owner.MakeNoise(Pawn(Owner).SoundDampening);
	    GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
	    StartTrace = Owner.Location + CalcDrawOffset() + FireOffset.Y * Y + FireOffset.Z * Z;
	    AdjustedAim = pawn(owner).AdjustAim(ProjectileSpeed, StartTrace, 2.75*AimError, True, True);
	    EndTrace = StartTrace + Accuracy * (FRand() - 0.5 )* Y * 1000
		    + Accuracy * (FRand() - 0.5 ) * Z * 1000;
	    AimDir = vector(AdjustedAim);
	    EndTrace += (10000 * AimDir);
	    if(FireTag=="primary")
	    {
            Spawn(ProjectileClass,,, StartTrace + 32 * AimDir,rotator(EndTrace - StartTrace));
        }
        else if(FireTag=="secondary")
        {
            Spawn(AltProjectileClass,,, StartTrace + 32 * AimDir,rotator(EndTrace - StartTrace));
        }
    }
    else
    {
    	Owner.MakeNoise(Pawn(Owner).SoundDampening);
	    GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
	    StartTrace = Owner.Location + CalcDrawOffset() + FireOffset.Y * Y + FireOffset.Z * Z;
	    AdjustedAim = pawn(owner).AdjustAim(1000000, StartTrace, 2.75*AimError, False, False);
	    EndTrace = StartTrace + Accuracy * (FRand() - 0.5 )* Y * 1000
            + Accuracy * (FRand() - 0.5 ) * Z * 1000;
        AimDir = vector(AdjustedAim);
	    EndTrace += (10000 * AimDir);
	    Other = Pawn(Owner).TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);

	    Count++;
	    if ( Count == 4 )
	    {
		    Count = 0;
		    if ( VSize(HitLocation - StartTrace) > 250 )
			    Spawn(class'MTracer',,, StartTrace + 96 * AimDir,rotator(EndTrace - StartTrace));
	    }
	    ProcessTraceHit(Other, HitLocation, HitNormal, vector(AdjustedAim),Y,Z);
    }
}

function Fire( float Value )
{
	Enable('Tick');
	if ( AmmoType == None )
	{
		// ammocheck
		GiveAmmo(Pawn(Owner));
	}
	if ( AmmoType.UseAmmo(1) )
	{
	    FireTag="primary";
		SoundVolume = 255*Pawn(Owner).SoundDampening;
		Pawn(Owner).PlayRecoil(FiringSpeed);
		bCanClientFire = true;
		bPointing=True;
		ShotAccuracy = 0.2;
		ClientFire(value);
		GotoState('NormalFire');
	}
	else GoToState('Idle');
}

function AltFire( float Value )
{
	Enable('Tick');
	if ( AmmoType == None )
	{
		// ammocheck
		GiveAmmo(Pawn(Owner));
	}
	if ( AmmoType.UseAmmo(1) )
	{
		FireTag="secondary";
        bPointing=True;
		bCanClientFire = true;
		ShotAccuracy = 0.95;
		Pawn(Owner).PlayRecoil(FiringSpeed);
		SoundVolume = 255*Pawn(Owner).SoundDampening;
		ClientAltFire(value);
		GoToState('AltFiring');
	}
	else GoToState('Idle');
}

simulated function PostBeginPlay()
{
    super.PostBeginPlay();
    switch(PrimaryProj)
    {
        case 0:
            ProjectileClass=None;
            break;
        case 1:
            ProjectileClass=class'ProjSwap.PS_SmallBioProj';
            break;
        case 2:
            ProjectileClass=class'ProjSwap.PS_LargeBioProj';
            break;
        case 3:
            ProjectileClass=class'ProjSwap.PS_ShockProj';
            break;
        case 4:
            ProjectileClass=class'ProjSwap.PS_PulseProj';
            break;
        case 5:
            ProjectileClass=class'ProjSwap.PS_RazorProj';
            break;
        case 6:
            ProjectileClass=class'ProjSwap.PS_RazorAltProj';
            break;
        case 7:
            ProjectileClass=class'ProjSwap.PS_FlakChunkProj';
            break;
        case 8:
            ProjectileClass=class'ProjSwap.PS_FlakShellProj';
            break;
        case 9:
            ProjectileClass=class'ProjSwap.PS_RocketProj';
            break;
        case 10:
            ProjectileClass=class'ProjSwap.PS_GrenadeProj';
            break;
        case 11:
            ProjectileClass=class'ProjSwap.PS_WarheadProj';
            break;
    }
    switch(SecondaryProj)
    {
        case 0:
            AltProjectileClass=None;
            break;
        case 1:
            AltProjectileClass=class'ProjSwap.PS_SmallBioProj';
            break;
        case 2:
            AltProjectileClass=class'ProjSwap.PS_LargeBioProj';
            break;
        case 3:
            AltProjectileClass=class'ProjSwap.PS_ShockProj';
            break;
        case 4:
            AltProjectileClass=class'ProjSwap.PS_PulseProj';
            break;
        case 5:
            AltProjectileClass=class'ProjSwap.PS_RazorProj';
            break;
        case 6:
            AltProjectileClass=class'ProjSwap.PS_RazorAltProj';
            break;
        case 7:
            AltProjectileClass=class'ProjSwap.PS_FlakChunkProj';
            break;
        case 8:
            AltProjectileClass=class'ProjSwap.PS_FlakShellProj';
            break;
        case 9:
            AltProjectileClass=class'ProjSwap.PS_RocketProj';
            break;
        case 10:
            AltProjectileClass=class'ProjSwap.PS_GrenadeProj';
            break;
        case 11:
            AltProjectileClass=class'ProjSwap.PS_WarheadProj';
            break;
    }
}
defaultproperties
{
}
