//*****************************************************************************
// PS_RocketLauncher -- Modified Rocket Launcher
// Created by mrbond113
//*****************************************************************************

class PS_RocketLauncher extends UT_Eightball config(ProjSwap);

var config int PrimaryProj;
var config int SecondaryProj;

state FireRockets
{
	function Fire(float F) {}
	function AltFire(float F) {}

	function ForceFire()
	{
		bForceFire = true;
	}

	function ForceAltFire()
	{
		bForceAltFire = true;
	}

	function bool SplashJump()
	{
		return false;
	}

	function BeginState()
	{
		local vector FireLocation, StartLoc, X,Y,Z;
		local rotator FireRot, RandRot;
		local Projectile r;
		local UT_SeekingRocket s;
		local Projectile g;
		local float Angle, RocketRad;
		local pawn BestTarget, PawnOwner;
		local PlayerPawn PlayerOwner;
		local int DupRockets;
		local bool bMultiRockets;

		PawnOwner = Pawn(Owner);
		if ( PawnOwner == None )
			return;
		PawnOwner.PlayRecoil(FiringSpeed);
		PlayerOwner = PlayerPawn(Owner);
		Angle = 0;
		DupRockets = RocketsLoaded - 1;
		if (DupRockets < 0) DupRockets = 0;
		if ( PlayerOwner == None )
			bTightWad = ( FRand() * 4 < PawnOwner.skill );

		GetAxes(PawnOwner.ViewRotation,X,Y,Z);
		StartLoc = Owner.Location + CalcDrawOffset() + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;

		if ( bFireLoad )
			AdjustedAim = PawnOwner.AdjustAim(ProjectileSpeed, StartLoc, AimError, True, bWarnTarget);
		else
			AdjustedAim = PawnOwner.AdjustToss(AltProjectileSpeed, StartLoc, AimError, True, bAltWarnTarget);

		if ( PlayerOwner != None )
			AdjustedAim = PawnOwner.ViewRotation;

		PlayRFiring(RocketsLoaded-1);
		Owner.MakeNoise(PawnOwner.SoundDampening);
		if ( !bFireLoad )
		{
			LockedTarget = None;
			bLockedOn = false;
		}
		else if ( LockedTarget != None )
		{
			BestTarget = Pawn(CheckTarget());
			if ( (LockedTarget!=None) && (LockedTarget != BestTarget) )
			{
				LockedTarget = None;
				bLockedOn=False;
			}
		}
		else
			BestTarget = None;
		bPendingLock = false;
		bPointing = true;
		FireRot = AdjustedAim;
		RocketRad = 4;
		if (bTightWad || !bFireLoad) RocketRad=7;
		bMultiRockets = ( RocketsLoaded > 1 );
		While ( RocketsLoaded > 0 )
		{
			if ( bMultiRockets )
				Firelocation = StartLoc - (Sin(Angle)*RocketRad - 7.5)*Y + (Cos(Angle)*RocketRad - 7)*Z - X * 4 * FRand();
			else
				FireLocation = StartLoc;
			if (bFireLoad)
			{
				if ( Angle > 0 )
				{
					if ( Angle < 3 && !bTightWad)
						FireRot.Yaw = AdjustedAim.Yaw - Angle * 600;
					else if ( Angle > 3.5 && !bTightWad)
						FireRot.Yaw = AdjustedAim.Yaw + (Angle - 3)  * 600;
					else
						FireRot.Yaw = AdjustedAim.Yaw;
				}
				if ( LockedTarget != None && ProjectileClass==class'Botpack.rocketmk2')
				{
					s = Spawn( class 'ut_SeekingRocket',, '', FireLocation,FireRot);
					s.Seeking = LockedTarget;
					s.NumExtraRockets = DupRockets;
					if ( Angle > 0 )
						s.Velocity *= (0.9 + 0.2 * FRand());
				}
				else
				{
					r = Spawn( ProjectileClass,, '', FireLocation,FireRot);
//					if (RocketsLoaded>4 && bTightWad) r.bRing=True;
					if ( Angle > 0 )
						r.Velocity *= (0.9 + 0.2 * FRand());
				}
			}
			else
			{
				g = Spawn( AltProjectileClass,, '', FireLocation,AdjustedAim);
				if ( DupRockets > 0 )
				{
					RandRot.Pitch = FRand() * 1500 - 750;
					RandRot.Yaw = FRand() * 1500 - 750;
					RandRot.Roll = FRand() * 1500 - 750;
					g.Velocity = g.Velocity >> RandRot;
				}
			}

			Angle += 1.0484; //2*3.1415/6;
			RocketsLoaded--;
		}
		bTightWad=False;
		bRotated = false;
	}

	function AnimEnd()
	{
		if ( !bRotated && (AmmoType.AmmoAmount > 0) )
		{
			PlayLoading(1.5,0);
			RocketsLoaded = 1;
			bRotated = true;
			return;
		}
		LockedTarget = None;
		Finish();
	}
Begin:
}

simulated function PostBeginPlay()
{
    switch(PrimaryProj)
    {
        case 0:
            ProjectileClass=class'Botpack.rocketmk2';
            break;
        case 1:
            ProjectileClass=class'ProjSwap.PS_SmallBioProj';
            break;
        case 2:
            ProjectileClass=class'ProjSwap.PS_LargeBioProj';
            break;
        case 3:
            ProjectileClass=class'ProjSwap.PS_ShockProj';
            break;
        case 4:
            ProjectileClass=class'ProjSwap.PS_PulseProj';
            break;
        case 5:
            ProjectileClass=class'ProjSwap.PS_RazorProj';
            break;
        case 6:
            ProjectileClass=class'ProjSwap.PS_RazorAltProj';
            break;
        case 7:
            ProjectileClass=class'ProjSwap.PS_FlakChunkProj';
            break;
        case 8:
            ProjectileClass=class'ProjSwap.PS_FlakShellProj';
            break;
        case 9:
            ProjectileClass=class'ProjSwap.PS_RocketProj';
            break;
        case 10:
            ProjectileClass=class'ProjSwap.PS_GrenadeProj';
            break;
        case 11:
            ProjectileClass=class'ProjSwap.PS_WarheadProj';
            break;
    }
    switch(SecondaryProj)
    {
        case 0:
            AltProjectileClass=class'Botpack.UT_Grenade';
            break;
        case 1:
            AltProjectileClass=class'ProjSwap.PS_SmallBioProj';
            break;
        case 2:
            AltProjectileClass=class'ProjSwap.PS_LargeBioProj';
            break;
        case 3:
            AltProjectileClass=class'ProjSwap.PS_ShockProj';
            break;
        case 4:
            AltProjectileClass=class'ProjSwap.PS_PulseProj';
            break;
        case 5:
            AltProjectileClass=class'ProjSwap.PS_RazorProj';
            break;
        case 6:
            AltProjectileClass=class'ProjSwap.PS_RazorAltProj';
            break;
        case 7:
            AltProjectileClass=class'ProjSwap.PS_FlakChunkProj';
            break;
        case 8:
            AltProjectileClass=class'ProjSwap.PS_FlakShellProj';
            break;
        case 9:
            AltProjectileClass=class'ProjSwap.PS_RocketProj';
            break;
        case 10:
            AltProjectileClass=class'ProjSwap.PS_GrenadeProj';
            break;
        case 11:
            AltProjectileClass=class'ProjSwap.PS_WarheadProj';
            break;
    }
    super.PostBeginPlay();
}
defaultproperties
{
}
