//*****************************************************************************
// PS_ShockRifle -- Modified Shock Rifle
// Created by mrbond113
//*****************************************************************************

class PS_ShockRifle extends ShockRifle config(ProjSwap);

var config int PrimaryProj;
var config int SecondaryProj;

function TraceFire( float Accuracy )
{
	local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z;
	local actor Other;

	Owner.MakeNoise(Pawn(Owner).SoundDampening);
	GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
	StartTrace = Owner.Location + CalcDrawOffset() + FireOffset.Y * Y + FireOffset.Z * Z;
	EndTrace = StartTrace + Accuracy * (FRand() - 0.5 )* Y * 1000
		+ Accuracy * (FRand() - 0.5 ) * Z * 1000 ;

	if ( bBotSpecialMove && (Tracked != None)
		&& (((Owner.Acceleration == vect(0,0,0)) && (VSize(Owner.Velocity) < 40)) ||
			(Normal(Owner.Velocity) Dot Normal(Tracked.Velocity) > 0.95)) )
		EndTrace += 10000 * Normal(Tracked.Location - StartTrace);
	else
	{
		AdjustedAim = pawn(owner).AdjustAim(1000000, StartTrace, 2.75*AimError, False, False);
		EndTrace += (10000 * vector(AdjustedAim));
	}

	Tracked = None;
	bBotSpecialMove = false;

	Other = Pawn(Owner).TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);

	if(ProjectileClass != None)
	{
	    Spawn(ProjectileClass,,, StartTrace + 16 * X,rotator(EndTrace - StartTrace));
	}
	else
	{
	    ProcessTraceHit(Other, HitLocation, HitNormal, vector(AdjustedAim),Y,Z);
    }
}

simulated function PostBeginPlay()
{
    switch(PrimaryProj)
    {
        case 0:
            ProjectileClass=None;
            break;
        case 1:
            ProjectileClass=class'ProjSwap.PS_SmallBioProj';
            break;
        case 2:
            ProjectileClass=class'ProjSwap.PS_LargeBioProj';
            break;
        case 3:
            ProjectileClass=class'ProjSwap.PS_ShockProj';
            break;
        case 4:
            ProjectileClass=class'ProjSwap.PS_PulseProj';
            break;
        case 5:
            ProjectileClass=class'ProjSwap.PS_RazorProj';
            break;
        case 6:
            ProjectileClass=class'ProjSwap.PS_RazorAltProj';
            break;
        case 7:
            ProjectileClass=class'ProjSwap.PS_FlakChunkProj';
            break;
        case 8:
            ProjectileClass=class'ProjSwap.PS_FlakShellProj';
            break;
        case 9:
            ProjectileClass=class'ProjSwap.PS_RocketProj';
            break;
        case 10:
            ProjectileClass=class'ProjSwap.PS_GrenadeProj';
            break;
        case 11:
            ProjectileClass=class'ProjSwap.PS_WarheadProj';
            break;
    }
    switch(SecondaryProj)
    {
        case 0:
            AltProjectileClass=class'Botpack.ShockProj';
            break;
        case 1:
            AltProjectileClass=class'ProjSwap.PS_SmallBioProj';
            break;
        case 2:
            AltProjectileClass=class'ProjSwap.PS_LargeBioProj';
            break;
        case 3:
            AltProjectileClass=class'ProjSwap.PS_ShockProj';
            break;
        case 4:
            AltProjectileClass=class'ProjSwap.PS_PulseProj';
            break;
        case 5:
            AltProjectileClass=class'ProjSwap.PS_RazorProj';
            break;
        case 6:
            AltProjectileClass=class'ProjSwap.PS_RazorAltProj';
            break;
        case 7:
            AltProjectileClass=class'ProjSwap.PS_FlakChunkProj';
            break;
        case 8:
            AltProjectileClass=class'ProjSwap.PS_FlakShellProj';
            break;
        case 9:
            AltProjectileClass=class'ProjSwap.PS_RocketProj';
            break;
        case 10:
            AltProjectileClass=class'ProjSwap.PS_GrenadeProj';
            break;
        case 11:
            AltProjectileClass=class'ProjSwap.PS_WarheadProj';
            break;
    }
    super.PostBeginPlay();
}
defaultproperties
{
}
